import java.sql.*;
import java.io.*;
import java.util.*;

class bibliotecaGiovani {

   static {
      try {
         // register the driver with DriverManager
         Class.forName("org.postgresql.Driver").newInstance();
      } catch (Exception e) {
         e.printStackTrace();
      }
   }

   public static void main(String argv[]) {
      Connection con = null;
	try{


            // Connect to DB. URL is jdbc:postgresql:DB
            String url = "jdbc:postgresql://127.0.0.1/postgres";
            String userid = "postgres";
            String passwd = "toto";
            con = DriverManager.getConnection(url, userid, passwd);

            System.out.println("...sono pronto per iniziare. Vai!");

            Statement stmt = con.createStatement();

            // Drop di schemi e tabelle per evitare problemi in caso di esecuzioni
            // ripetute del programma. Da completare ...
            stmt.executeUpdate("drop schema if exists biblioteca_giovani cascade");

            // Creazione di schemi e tabelle
            stmt.executeUpdate("CREATE SCHEMA biblioteca_giovani");
            stmt.executeUpdate("CREATE TABLE biblioteca_giovani.libri_teen (ISBN VARCHAR  PRIMARY KEY, "
                    + "titolo VARCHAR(40), "
                    + "autore VARCHAR(40))");

            // Esecuzione query ed utilizzo del risultato per il popolamento delle tabelle classifica_nazioni e specialisti_piano_IT
            // (opportunamente definite) mediante PreparedStatement

            ResultSet rs = stmt.executeQuery(
                    "SELECT L.ISBN, L.titolo, L.autore "
                    + "FROM (libro L NATURAL JOIN ha_letto H) "
                    + "JOIN socio S ON S.id_socio=H.socio "
                    + "WHERE S.eta>=13 AND S.eta<=19 "
                    + "GROUP BY L.ISBN, L.titolo, L.autore "
                    + "HAVING COUNT(*)>=2");

            PreparedStatement ps = con.prepareStatement("INSERT INTO biblioteca_giovani.libri_teen VALUES (?, ?, ?)");

            while (rs.next()) {
                String ISBN = rs.getString(1);
                String titolo = rs.getString(2);
                String autore = rs.getString(3);

                ps.setString(1, ISBN);
                ps.setString(2, titolo);
                ps.setString(3, autore);

                ps.executeUpdate();
            }

            //Stampa su file
            PrintWriter pw = new PrintWriter("C:\\greenBib.txt");
            pw.println("ISBN\t\t\t titolo \t\t\t\t autore");
            pw.println("======================================================");


            // Cicliamo su tutte le tuple di SPECIALITA_NUOTO_ITA
            rs = stmt.executeQuery("SELECT * FROM libri_teen");
            while (rs.next()) {
                String ISBN = rs.getString(1);
                String titolo = rs.getString(2);
                String autore = rs.getString(3);



                // Stampiamo la tupla presa da SPECIALITA_NUOTO_ITA insieme
                // al numero totale di gare.
                pw.println(String.format("%s\t%s\t%s\t", ISBN, titolo, autore));
            }


            //Chiusura oggetti: Da completare.
            System.out.println("...chiudo tutto!");
            stmt.close();
            ps.close();
            rs.close();
            pw.close();
            con.close();
        } catch( Exception e ) {
         e.printStackTrace();
        }
   }
}



